<?php
/**
 * stanislav.elbl, 02.11.2015
 */

namespace Ron;

class EMailAttachment
{
    var $fileName;
    var $content;

    /**
     * eMailAttachment constructor.
     * @param $fileName
     * @param $content
     */
    public function __construct($fileName, $content)
    {
        $this->fileName = $fileName;
        $this->content = $content;
    }
}



class EMail
{
    var $from;
    var $fromName;

    var $to;
    var $copyTo;
    var $blindCopyTo;
    var $replyTo;

    var $subject;
    var $text;

    /** @var EMailAttachment[] $attachments */
    var $attachments = [];

    var $sendHtml = null; // podle nastaveni maileru


    function addAttachment($fileName, $content)
    {
        $this ->attachments[] = new EMailAttachment($fileName, $content);
    }

    function __toString()
    {
        return
            "Od:  $this->from 
            Jmeno odesilatele: $this->fromName 
            Komu: $this->to 
            Kopie: $this->copyTo 
            Skryta kopie: $this->blindCopyTo
            Odpoved: $this->replyTo
            Predmet: $this->subject
            Text: $this->text";
    }

    function convertToUTF8()
    {
        $this ->subject = StringUtils::toUTF8($this ->subject);
        $this ->text = StringUtils::toUTF8($this ->text);
        $this ->fromName = StringUtils::toUTF8($this ->fromName);
    }

    function getSubject()
    {
        global $mailer_subject_prefix;
        return ($mailer_subject_prefix ?: '') . $this->subject;
    }

}
