<?php
/**
 * stanislav.elbl, 16.03.2021
 */

namespace RonPortal\Dochazka;

use Ron\Controls\LinksList;
use Ron\TextManager;
use RonPortal\Controls\RonPortalFilterForm;
use RonPortal\Prava;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalSettings;

class SchvalovaniFilterForm extends RonPortalFilterForm
{
    function __construct($database)
    {
        parent::__construct($database, 'schvalovani', true);

        $this->nastavObdobi(true, 'ADS', false);  // jenotevrene = false
        $this->nastavRozdeleni(true);

        $this->f_pravarozdeleni = Prava::vratPrava('prohlizeni');

        if (RonPortalSettings::getIntValue(RonPortalSettings::ROZDELENI2_TYP)) {
            $this->nastavRozdeleni2(true);
        }
    }


    function loadData()
    {
        parent::loadData();

        if (isset($_GET['urovenschvaleni'])) {
            $value = (int)$_GET['urovenschvaleni'];
            $_SESSION['filtr_urovenschvaleni'] = $value;
        }

        if (isset($_GET['kontroly'])) {
            $value = (int)$_GET['kontroly'];
            $_SESSION['filtr_kontrolydochazky'] = $value;
        }
    }


    function renderFilterStav()
    {
        echo '<div class="filterrow" id="filter_urovenschvaleni">';
        echo '<span class="filtercaption"></span>';

//        if (isset($_GET['urovenschvaleni'])) {
//            $actualvalue = (int)$_GET['urovenschvaleni'];
//            $_SESSION['filtr_urovenschvaleni'] = $actualvalue;
//        } else {
//            $actualvalue = (int)$_SESSION['filtr_urovenschvaleni'];
//        }


//        global $STR_Neschvaleno1; // jen pro kompatibilitu starych prekladu
//        global $STR_Neschvaleno2;
//        global $STR_Neschvaleno3;

        LinksList::renderLinks([
            0 => TextManager::_('Vsechno'),
            1 => TextManager::_('Neschvaleno1'),
            2 => TextManager::_('Neschvaleno2'),
            3 => TextManager::_('Neschvaleno3')
        ],
            (int)RonPortalSession::getValue('filtr_urovenschvaleni'), '?menuid=schvalovani&urovenschvaleni=', '', false);

        echo "</div>\n";
    }


    function renderFilterChyby()
    {
        echo '<div class="filterrow" id="filter_kontroly">';
        echo '<span class="filtercaption"></span>';

        LinksList::renderLinks([
            0 => TextManager::_('Vsechno'),
            1 => TextManager::_('Jen_s_chybami_v_dochazce'),
            2 => TextManager::_('Jen_bez_chyb_v_dochazce')
        ],
            (int)RonPortalSession::getValue('filtr_kontrolydochazky'), '?menuid=schvalovani&kontroly=', '', false);

        echo "</div>\n";
    }


    function renderFilters()
    {
        parent::renderFilters();

        // vsechno / nezpracovano / nezkontrolovano / neschvaleno
        $this->renderFilterStav();
        // vsechno / s chybami / bez chyb
        $this ->renderFilterChyby();
    }


    function getFiltrKontroly()
    {
        $kontroly = (int)RonPortalSession::getValue('filtr_kontrolydochazky');
        if (!$kontroly) {
            return '';
        }

        return
            ($kontroly === 2 ? 'NOT ' : '') . 'EXISTS (' .
            'SELECT * FROM VysledekKontrolyDochazky, TypKontrolyDochazky' .
            ' WHERE VysledekKontrolyDochazky.TypKontroly = TypKontrolyDochazky.Kod' .
            ' AND TypKontrolyDochazky.Kategorie > 10' .  // vynecha typ 10=informace
            ' AND VysledekKontrolyDochazky.Ignorovat = 0' .
            ' AND VysledekKontrolyDochazky.RC = PracovniPomer.RC' .
            ' AND VysledekKontrolyDochazky.OsobniCislo = PracovniPomer.OsobniCislo' .
            ' AND VysledekKontrolyDochazky.DatumNastupu = PracovniPomer.DatumNastupu' .
            ' AND VysledekKontrolyDochazky.Datum >= ' . $this ->database ->dateToString($this ->vybraneObdobiOd) .
            ' AND VysledekKontrolyDochazky.Datum <= ' . $this ->database ->dateToString($this ->vybraneObdobiDo) .
            ')';
    }
}
